;; meta stuff
(let ((usr-backup (locate-user-emacs-file "backup"))
      (usr-custom (locate-user-emacs-file "custom.el")))
  (setq auto-save-default              nil
        backup-directory-alist         `((".*" . ,usr-backup))
        create-lockfiles               nil
        custom-file                    usr-custom
        file-name-handler-alist        nil
        gc-cons-threshold              (* 200 1000 1000)
        global-mark-ring-max           1024
        inhibit-compacting-font-caches t
        inhibit-startup-screen         t
        initial-scratch-message        nil
        mark-ring-max                  1024))

(if (eq system-type 'windows-nt)
    (progn
      (setenv "PATH" (concat "C:/emacs/bin;" (getenv "PATH")))
      (defalias 'agw-flyspell-mode      #'ignore)
      (defalias 'agw-flyspell-prog-mode #'ignore))
  (progn
    (defalias 'agw-flyspell-mode      #'flyspell-mode)
    (defalias 'agw-flyspell-prog-mode #'flyspell-prog-mode)))

;; important ergonomics
(setq fill-column 80
      sentence-end-double-space nil
      ring-bell-function #'ignore)

(defalias #'yes-or-no-p #'y-or-n-p)

;; packages
(setq package-archives '(("melpa" . "https://melpa.org/packages/")
                         ("gnu"   . "https://elpa.gnu.org/packages/")))

;; default visuals
(add-to-list 'default-frame-alist '(width  . 80))
(add-to-list 'default-frame-alist '(height . 30))

(set-face-attribute 'default nil :family "Courier Prime Code"
                    :height 120 :weight 'normal :width 'normal)

(copy-face 'default 'fixed-pitch)
(copy-face 'default 'mode-line)

;; fontset usage
(dolist (range '((#x2310  . #x26bf)
                 (#x26c0  . #x329f)
                 (#x1f000 . #x1fa9f)))
  (set-fontset-font t range "Noto Color Emoji"))

(set-fontset-font t '(#x2e80 . #x9fff) "Noto Sans CJK JP")

;; EOF
